// ;|
// Author:          Roy Klein Gebbinck (www.b-k-g.nl)
// Version:         20170825: Added workaround to update leaders.
//                  20170806: Several improvements.
// New version for: https://forum.bricsys.com/discussion/32898/edit-of-dimension
// Original for:    https://forum.bricsys.com/discussion/18333/how-do-change-edit-text-box-size
//
// This is a 'mixed mode file': it contains DCL and LSP code.
// See: https://www.theswamp.org/index.php?topic=52289.msg572643#msg572643

AltEdit : dialog {
  fixed_width = false;
  initial_focus = "input";
  label = "AltEdit";
  : edit_box {
    key = "input";
    allow_accept = true;
    fixed_width_font = true;
    width = 60;
  }
  ok_cancel;
}
/* |;

(defun c:AltEdit ( / dcl doc enm fnm new old ret ss txtP)
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-endundomark doc)
  (vla-startundomark doc)
  (if
    (and
      (or
        (and
          (setq ss (cadr (ssgetfirst)))
          (= 1 (sslength ss))
          (setq enm (ssname ss 0))
        )
        (setq enm (car (entsel)))
      )
      (setq obj (vlax-ename->vla-object enm))
      (or
        (and
          (vlax-property-available-p obj 'textstring) ; For texts and mtexts.
          (setq txtP T)
        )
        ;; The textoverride property is not yet available in BricsCAD for Linux:
        (wcmatch (vle-entget 0 enm) "*DIMENSION*") ; For dimensions.
        (prompt "\nError: entity not supported ")
      )
      (or
        (and
          (setq fnm
            (vl-some
              '(lambda (str)
                (if (wcmatch (strcase str) "*ALTEDIT*") str) ; This file's name must match "*ALTEDIT*".
              )
              (reverse (vl-list-loaded-lisp))
            )
          )
          (< 0 (setq dcl (load_dialog fnm)))
        )
        (prompt "\nError: dcl dialog not found ")
      )
    )
    (progn
      (if txtP
        (setq old (vla-get-textstring obj))
        (if (= "" (setq old (vle-entget 1 enm)))
          (setq old "<>")
        )
      )
      (if (not *AltEdit_diaPos*) (setq *AltEdit_diaPos* '(-1 -1)))
      (new_dialog "AltEdit" dcl "" *AltEdit_diaPos*)
      (set_tile "input" old)
      (action_tile "input"  "(setq new $value)")
      (action_tile "accept" "(setq *AltEdit_diaPos* (done_dialog 1))")
      (action_tile "cancel" "(setq *AltEdit_diaPos* (done_dialog 0))")
      (setq ret (start_dialog))
      (unload_dialog dcl)
      (if
        (and
          (= 1 ret)
          new
          (/= old new)
        )
        (if txtP
          (progn
            (vla-put-textstring obj new)
            ;; Workaround to update leaders:
            ;; In V14 a single move from (0.0 0.0 0.0) to (0.0 0.0 0.0) works, but not in V15 and V16.
            (if (= "{ACAD_REACTORS" (vle-entget 102 enm)) ; Enm is probably an mtext belonging to a leader.
              (progn
                (setvar 'cmdecho 0)
                (command "_.move" enm "" "_non" '(0.0 0.0 0.0) "_non" '(1e-8 0.0 0.0))
                (command "_.move" enm "" "_non" '(1e-8 0.0 0.0) "_non" '(0.0 0.0 0.0))
                (setvar 'cmdecho 1)
              )
            )
          )
          (vle-entmod 1 enm (if (= "<>" new) "" new))
        )
      )
    )
  )
  (vla-endundomark doc)
  (princ)
)
